/* DuduSDL
 * dudusdl_2.c
 *
 * Copyright (C) 2000 Nicolas Peninguy and Colin Leroy
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "dudusdl.h"

int CPUx, CPUy,bCPUx,bCPUy;
//demande et stocke les paramtres
// nombre de joueurs, rapidit...
void demander_parametres(void)
{
  int option = 1;
  int done = 0;
  int enable_cpu = 0;
  
  best_angleCPU_found = 0;
  angleCPU= 3.14/2;
  CPU_direction = 1;
  Init_all(640, 480, 8, videoflags); //SDL_SWSURFACE | SDL_FULLSCREEN);

  //  printf(DATADIR"doto.pcx\n");

  /*  InitKeyScan ();
  if (SetSVGA ())
    Quit ("Votre carte video n'est pas supportee, c'est dommage.");
  InitGameLib (640, 960);
  */
  if (LoadPic (DATADIR"/options.pcx", 205))
    Quit ("Erreur PCX. Verifiez le fichier options.pcx");
  if (LoadPic (DATADIR"/oui.pcx", 286))
    Quit ("Erreur PCX. Verifiez le fichier oui.pcx");
  if (LoadPic (DATADIR"/non.pcx", 285))
    Quit ("Erreur PCX. Verifiez le fichier non.pcx");
  if (LoadPic (DATADIR"/j1.pcx", 296))
    Quit ("Erreur PCX. Verifiez le fichier j1.pcx");
  if (LoadPic (DATADIR"/j2.pcx", 297))
    Quit ("Erreur PCX. Verifiez le fichier j2.pcx");
  if (LoadPic (DATADIR"/j3.pcx", 298))
    Quit ("Erreur PCX. Verifiez le fichier j3.pcx");
  if (LoadPic (DATADIR"/j4.pcx", 299))
    Quit ("Erreur PCX. Verifiez le fichier j4.pcx");
  if (LoadPic (DATADIR"/point.pcx", 280))
    Quit ("Erreur PCX. Verifiez le fichier point.pcx");
  if (LoadPic (DATADIR"/clear.pcx", 281))
  Quit ("Erreur PCX. Verifiez le fichier clear.pcx");
  //  SetColour (0, 255, 255, 255);

  //  SDL_SetColorKey(screen, SDL_SRCCOLORKEY,
  //		  SDL_MapRGB(screen->format,255,255,255));
  
  if ( images[205]->format->palette ) {
    SDL_SetColors(screen, images[205]->format->palette->colors,
		  0, images[205]->format->palette->ncolors);
    //    printf("ncolors = %d\n", images[205]->format->palette->ncolors);
  }
  SDL_SetColorKey(screen, SDL_SRCCOLORKEY,
		  SDL_MapRGB(screen->format,255,255,255)); 
  //  ClearBuffer (0);
  PutPicM (205, 0, 0);
  
  PutPic (280, 50, 140);
  PutPic (296, 350, 140);
  PutPic (285, 350, 215);
  PutPic (285, 350, 285);
 
  nombreJoueurs = 1;
  for (i = 0; i <= 3; i++)
    joueurVivant[i] = 0;
  vitesseAxeY = 5;
  modeViolent = 0;
  gravite = 0;

  DisplayBuffer (0, 0);

  SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,
  		      SDL_DEFAULT_REPEAT_INTERVAL);

  do
    {				//savoir quelle option on rgle
      if (option == 1)
	{
	  PutPic (280, 50, 140);
	  PutPic (281, 50, 215);
	  PutPic (281, 50, 285);
	}
      if (option == 2)
	{
	  PutPic (280, 50, 215);
	  PutPic (281, 50, 140);
	  PutPic (281, 50, 285);
	}
      if (option == 3)
	{
	  PutPic (280, 50, 285);
	  PutPic (281, 50, 140);
	  PutPic (281, 50, 215);
	}

      DisplayBuffer (0, 0);

      // This part was completely rewritten
      
      SDL_WaitEvent(&event);

      switch (event.type) {
      case SDL_KEYDOWN:
	switch (event.key.keysym.sym) {
	case SDLK_DOWN:
	  option++;
	  if (option > 3)
	    option = 1;
	  break;
	case SDLK_UP:
	  option--;
	  if (option < 1)
	    option = 3;
	  break;
	case SDLK_LEFT:
	  switch (option) {
	  case 1:
	    nombreJoueurs--;
	    if (nombreJoueurs < 1)
	      nombreJoueurs = 2;
	    PutPic (296 + (nombreJoueurs - 1), 350, 140);
	    break;
	  case 2:
	    modeViolent = !modeViolent;
	    PutPic (285 + modeViolent, 350, 215);
	    break;
	  case 3:
	    gravite = !gravite;
	    PutPic (285 + gravite, 350, 285);
	    break;
	  default:
	    Quit("Bug dans demander parametres\n");
	    break;
	  }
	  break;
	case SDLK_RIGHT:
	  switch (option) {
	  case 1:
	    nombreJoueurs++;
	    if (nombreJoueurs > 2)
	      nombreJoueurs = 1;
	    PutPic (296 + (nombreJoueurs - 1), 350, 140);
	    break;
	  case 2:
	    modeViolent = !modeViolent;
	    PutPic (285 + modeViolent, 350, 215);
	    break;
	  case 3:
	    gravite = !gravite;
	    PutPic (285 + gravite, 350, 285);
	    break;
	  default:
	    Quit("Bug dans demander parametres\n");
	  }
	  break;
	case SDLK_RETURN:
	  done = 1;
	  break;
	case SDLK_c:
	  enable_cpu = !enable_cpu;
	  break;
	default:
	  break;
	}
      default:
	break;
      }
    } while (!done);

  if (enable_cpu)
    {
      CPU = 1;
      CPUtire = 0;
      nombreJoueurs = 2;
    }
  else
    CPU = 0;
  nombreJoueurs--;
  for (i = 0; i <= nombreJoueurs; i++)
    joueurVivant[i] = 1;
  
}



//charge les images et initialise les graphiques
void
charger_donnes ()
{
  SDL_Event event;
  int strange = 0;
  int done = 0;
  int i;

  sleep(1);
  
  while (SDL_PollEvent(&event)) {
    if ((event.type == SDL_KEYDOWN) && (event.key.keysym.sym == SDLK_s))
      strange = 1;
    
  }

  //chargement des images
  if (!strange)
    {
      if (LoadPic (DATADIR"/dd.pcx", 10))
	Quit ("Erreur PCX. Verifiez le ficher dd.pcx");
      if (nombreJoueurs == 0)
	if (LoadPic (DATADIR"/fond1.pcx", 11))
	  Quit ("Erreur PCX. Verifiez le fichier fond1.pcx");
      if (nombreJoueurs == 1)
	if (LoadPic (DATADIR"/fond2.pcx", 11))
	  Quit ("Erreur PCX. Verifiez le fichier fond2.pcx");
      //      SetColour (0, 255, 255, 255);
      //      ClearBuffer (0);
      PutPicM (10, 0, 0);
      //      if ( images[11]->format->palette )
      //	SDL_SetColors(screen, images[11]->format->palette->colors,
      //		      0, images[11]->format->palette->ncolors);
      DisplayBuffer (0, 0);
      //      PFadeUp (10);
      dernierTemps = time (NULL);
      if (LoadPic (DATADIR"/cont.pcx", 20))
	Quit ("Erreur PCX. Verifiez le ficher cont.pcx");
      if (LoadPic (DATADIR"/pause.pcx", 30))
	Quit ("Erreur PCX. Verifiez le ficher pause.pcx");
      if (LoadPic (DATADIR"/1.pcx", 0))
	Quit ("Erreur PCX. Verifiez le ficher 1.pcx");
      if (LoadPic (DATADIR"/2.pcx", 1))
	Quit ("Erreur PCX. Verifiez le ficher 2.pcx");
      if (LoadPic (DATADIR"/3.pcx", 2))
	Quit ("Erreur PCX. Verifiez le ficher 3.pcx");
      if (LoadPic (DATADIR"/4.pcx", 3))
	Quit ("Erreur PCX. Verifiez le ficher 4.pcx");
      if (LoadPic (DATADIR"/5.pcx", 4))
	Quit ("Erreur PCX. Verifiez le ficher 5.pcx");
      if (LoadPic (DATADIR"/6.pcx", 5))
	Quit ("Erreur PCX. Verifiez le ficher 6.pcx");
      if (LoadPic (DATADIR"/gen.pcx", 40))
	Quit ("Erreur PCX. Verifiez le ficher gen.pcx");
      if (LoadPic (DATADIR"/p6.pcx", MALUS_ROUGE))
	Quit ("Erreur PCX. Verifiez le ficher p6.pcx");
      if (LoadPic (DATADIR"/p1.pcx", MALUS_JAUNE))
	Quit ("Erreur PCX. Verifiez le ficher p1.pcx");
      if (LoadPic (DATADIR"/expl.pcx", EXPLOSION))
	Quit ("Erreur PCX. Verifiez le ficher expl.pcx");
      if (LoadPic (DATADIR"/deux.pcx", FIN_EXPLOSION))
	Quit ("Erreur PCX. Verifiez le ficher deux.pcx");
      if (LoadPic (DATADIR"/gagne.pcx", GAGNE))
	Quit ("Erreur PCX. Verifiez le ficher gagne.pcx");
      if (LoadPic (DATADIR"/verin.pcx", VERIN))
	Quit ("Erreur PCX. Verifiez le ficher verin.pcx");
      if (LoadPic (DATADIR"/plateau.pcx", PLATEAU))
	Quit ("Erreur PCX. Verifiez le ficher plateau.pcx");
      if (LoadPic (DATADIR"/perdu.pcx", PERDU))
	Quit ("Erreur PCX. Verifiez le ficher perdu.pcx");
      if (LoadTXT (DATADIR"/text.pcx", 0, 16, 16))
	Quit ("Erreur Texte. Verifiez le ficher text.pcx");
      if (LoadTXT (DATADIR"/text2.pcx", 1, 8, 8))
      	Quit ("Erreur Texte. Verifiez le ficher text2.pcx");
      if (LoadPic (DATADIR"/rebours.pcx", REBOURS))
	Quit ("Erreur PCX. Verifiez le fichier rebours.pcx");
    }
  else
    {
      if (LoadPic (DATADIR"/dd2.pcx", 10))
	Quit ("Erreur PCX. Verifiez le ficher dd.pcx");
      if (nombreJoueurs == 0)
	if (LoadPic (DATADIR"/fond12.pcx", 11))
	  Quit ("Erreur PCX. Verifiez le fichier fond1.pcx");
      if (nombreJoueurs == 1)
	if (LoadPic (DATADIR"/fond22.pcx", 11))
	  Quit ("Erreur PCX. Verifiez le fichier fond2.pcx");
      //      SetColour (0, 255, 255, 255);
      //      ClearBuffer (0);
      PutPicM (10, 0, 0);
      DisplayBuffer (0, 0);
      //      PFadeUp (10);
      dernierTemps = time (NULL);
      if (LoadPic (DATADIR"/cont2.pcx", 20))
	Quit ("Erreur PCX. Verifiez le ficher cont.pcx");
      if (LoadPic (DATADIR"/pause2.pcx", 30))
	Quit ("Erreur PCX. Verifiez le ficher pause.pcx");
      if (LoadPic (DATADIR"/12.pcx", 0))
	Quit ("Erreur PCX. Verifiez le ficher 1.pcx");
      if (LoadPic (DATADIR"/22.pcx", 1))
	Quit ("Erreur PCX. Verifiez le ficher 2.pcx");
      if (LoadPic (DATADIR"/32.pcx", 2))
	Quit ("Erreur PCX. Verifiez le ficher 3.pcx");
      if (LoadPic (DATADIR"/42.pcx", 3))
	Quit ("Erreur PCX. Verifiez le ficher 4.pcx");
      if (LoadPic (DATADIR"/52.pcx", 4))
	Quit ("Erreur PCX. Verifiez le ficher 5.pcx");
      if (LoadPic (DATADIR"/62.pcx", 5))
	Quit ("Erreur PCX. Verifiez le ficher 6.pcx");
      if (LoadPic (DATADIR"/gen2.pcx", 40))
	Quit ("Erreur PCX. Verifiez le ficher gen2.pcx");
      if (LoadPic (DATADIR"/p62.pcx", MALUS_ROUGE))
	Quit ("Erreur PCX. Verifiez le ficher p6.pcx");
      if (LoadPic (DATADIR"/p12.pcx", MALUS_JAUNE))
	Quit ("Erreur PCX. Verifiez le ficher p1.pcx");
      if (LoadPic (DATADIR"/expl2.pcx", EXPLOSION))
	Quit ("Erreur PCX. Verifiez le ficher expl.pcx");
      if (LoadPic (DATADIR"/deux2.pcx", FIN_EXPLOSION))
	Quit ("Erreur PCX. Verifiez le ficher deux.pcx");
      if (LoadPic (DATADIR"/gagne2.pcx", GAGNE))
	Quit ("Erreur PCX. Verifiez le ficher gagne.pcx");
      if (LoadPic (DATADIR"/verin2.pcx", VERIN))
	Quit ("Erreur PCX. Verifiez le ficher verin.pcx");
      if (LoadPic (DATADIR"/plateau2.pcx", PLATEAU))
	Quit ("Erreur PCX. Verifiez le ficher plateau.pcx");
      if (LoadPic (DATADIR"/perdu2.pcx", PERDU))
	Quit ("Erreur PCX. Verifiez le ficher perdu.pcx");
      if (LoadTXT (DATADIR"/text.pcx", 0, 16, 16))
      	Quit ("Erreur Texte. Verifiez le ficher text.pcx");
      if (LoadTXT (DATADIR"/text2.pcx", 1, 8, 8))
      	Quit ("Erreur Texte. Verifiez le ficher text2.pcx");
      if (LoadPic (DATADIR"/rebours2.pcx", REBOURS))
	Quit ("Erreur PCX. Verifiez le fichier rebours.pcx");
    }
    
    usleep(900000);

  if ( images[11]->format->palette )
    SDL_SetColors(screen, images[11]->format->palette->colors,
		  0, images[11]->format->palette->ncolors);
  for(i=0;i<6;i++)
    SDL_SetColorKey(images[i], SDL_SRCCOLORKEY, SDL_MapRGB(screen->format,0,0,0));
  SDL_SetColorKey(images[(int)EXPLOSION], SDL_SRCCOLORKEY, SDL_MapRGB(screen->format,255,255,255));
  SDL_SetColorKey(images[(int)FIN_EXPLOSION], SDL_SRCCOLORKEY, SDL_MapRGB(screen->format,255,255,255));
}

int arrivee (int x, int y) {
  int rebondArrivee = 0, i, deltax, deltay, delta;
  if (y <= tableauJeu[1][2] + (degreDescente[1] * 16) + 8)
    rebondArrivee = 1;
  if (x < tableauJeu[1][0] + 8
      || x > tableauJeu[1][1] - 8)
    CPU_coef_dir = 3.1415 - CPU_coef_dir;
  for (i = 0; i <= bouleCourante[1] - 1; i++)
    if (bouleExiste[1][i] == bouleEtatExistence[1])
      {
	deltax =
	  x - bouleCoordX[1][i];
	deltay =
	  y - bouleCoordY[1][i];
	delta = deltax * deltax + deltay * deltay;

	if (delta < 250)
	  rebondArrivee = 1;

      }
  if(rebondArrivee) {
  int rangee=0;
  int clas = 0;
  for (i = 0; i < 17; i++)
    {
      if (y <
	  tableauJeu[1][2] + (degreDescente[1] + i +
					 1) * 16
	  && y  >=
	  tableauJeu[1][2] + (degreDescente[1] +
					 i) * 16)
	{
	  y  =
	    tableauJeu[1][2] + 8 + (degreDescente[1] +
					       i) * 16;
	  rangee = i;
	  clas++;
	}
    }

  if (rangee % 2 == 0)
    {
      if (x >
	  tableauJeu[1][0] + 12 * 16)
	x =
	  tableauJeu[1][0] + 8 + 11 * 16;
      if (x <=
	  tableauJeu[1][0])
	x =
	  tableauJeu[1][0] + 8;
      for (i = 0; i < 12; i++)
	{
	  if (x <
	      tableauJeu[1][0] + (i + 1) * 16
	      && x >=
	      tableauJeu[1][0] + i * 16)
	    {
	      x =
		tableauJeu[1][0] + 8 + i * 16;
	      clas++;
	    }
	}
    }
  else
    {
      if (x >
	  tableauJeu[1][0] + 8 + 12 * 16)
	x =
	  tableauJeu[1][0] + 12 * 16;
      if (x <=
	  tableauJeu[1][0] + 8)
	x =
	  tableauJeu[1][0] + 16;
      for (i = 0; i < 12; i++)
	{
	  if (x <
	      tableauJeu[1][0] + 8 + (i + 1) * 16
	      && x >=
	      tableauJeu[1][0] + 8 + i * 16)
	    {
	      x =
		tableauJeu[1][0] + 16 + i * 16;
	      clas++;
	    }
	}
    }
    CPUx=x; CPUy=y;
  }    
  return (rebondArrivee);
}

int countAll (int x, int y) {
  int colle[127], c, i, j;
  int deltax, deltay, delta;
  char deja[800];
  time_t heure1, heure2;
  struct tms tms1, tms2;
  int diff;

  for(i=0;i<800;i++)
    deja[i] = 0;

  colle[0] = -1;

  for (i = 1; i < 127; i++)
    colle[i] = LIBRE;

  p = 1;

  for (c = 0; c <= p; c++)
    {
      for (i = 0; i < bouleCourante[1] - 1; i++)
	if (bouleExiste[1][i] == bouleEtatExistence[1])
	  {
	    if(colle[c] != -1) {
	    deltax =
	      bouleCoordX[1][colle[c]] -
	      bouleCoordX[1][i];
	    deltay =
	      bouleCoordY[1][colle[c]] -
	      bouleCoordY[1][i];
	    } else {
	    deltax =
	      x - bouleCoordX[1][i];
	    deltay =
	      y - bouleCoordY[1][i];
	    }	    
	    delta = deltax * deltax + deltay * deltay;

	    if ((delta < 321
	    	&& colle[c] > -1
		&& i != colle[c]
		&& deja[i] == 0
		&& bouleCouleur[1][i] ==
		bouleCouleur[1][colle[c]])
	    ||  (colle[c] == -1
	        && delta < 321
		&& bouleCouleur[1][i] == bouleCouleur[1][bouleCourante[1]]))
	      {
		colle[p] = i;
		deja[i] = 1;
		p++;
	      }
	  }
    }

  for (i = 0; i <= bouleCourante[1] - 1; i++)
    deja[i] = 0;
  
  return p;
}
int CPUtry (void) {
	int x,y;
	x = viseurCoordX[1];
      	y = viseurCoordY[1] + 1;
	CPU_coef_dir = angleCPU;
	while (!arrivee(x,y)) {
		 x += vitesseAxeY * cos (CPU_coef_dir);
  		 y -= vitesseAxeY * sin (CPU_coef_dir);
	}
	return countAll(CPUx,CPUy);
}

void cpu_prepare () {
	if (CPUtire || (bouleArrivee[1][bouleCourante[1] - 1] == 0
			&&  bouleCourante[1]>48))
		return;
	if(!best_angleCPU_found) {
		if(angleCPU < 2.8 && CPU_direction > 0) 
			angleCPU += CPU_direction*0.03;
		else if(CPU_direction > 0)
			CPU_direction = -1;
		else if (angleCPU > 0.3)
			angleCPU += CPU_direction*0.03;
		else {
			best_angleCPU_found = 1;
			CPU_direction =1;
		}
		a[1] = angleCPU;
		if (best_CPU_shot < CPUtry()) {
		 	best_CPU_shot = CPUtry();
			best_angleCPU = angleCPU;
			bCPUx=CPUx;bCPUy=CPUy;
			return;
		}
		if(best_angleCPU_found && !best_CPU_shot) {
			best_angleCPU=1.0;
		}
	} else {
		if(angleCPU > best_angleCPU)
			angleCPU -= 0.03;
		else if (angleCPU < best_angleCPU)
			angleCPU += 0.03;
		a[1] = angleCPU;
		if(a[1] != best_angleCPU &&
		   angleCPU + 0.03 > best_angleCPU &&
		   angleCPU -0.03 < best_angleCPU) {
			angleCPU=best_angleCPU;
			a[1] = angleCPU;
		} else if (a[1]==best_angleCPU) {
			CPUtire = 1;
			best_CPU_shot = 0;
			best_angleCPU_found = 0;
		}
	}
}
